## kommit 1.6.0+p24.04+vstable+git20250927.0010

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(kommit)

set(PROJECT_VERSION_MAJOR 1)
set(PROJECT_VERSION_MINOR 6)
set(PROJECT_VERSION_PATCH 0)

set (RELEASE_SERVICE_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")

set(LIBKOMMIT_LIB_VERSION "${RELEASE_SERVICE_VERSION}")
set(LIBKOMMIT_LIB_SOVERSION "0")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")


set(QT_MIN_VERSION 5.15.2)
set(KF_MIN_VERSION 5.90.0)
set(KDE_COMPILERSETTINGS_LEVEL "5.82")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")

add_definitions(-DGK_VERSION="${RELEASE_SERVICE_VERSION}")

find_package(PkgConfig REQUIRED)
pkg_check_modules(LIBGIT2 "libgit2>=1.0" REQUIRED IMPORTED_TARGET)

find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)

set(
    CMAKE_MODULE_PATH
    ${ECM_MODULE_PATH}
    ${CMAKE_CURRENT_SOURCE_DIR}/cmake
)

include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings NO_POLICY_SCOPE)
include(FeatureSummary)

include(ECMInstallIcons)
include(ECMQtDeclareLoggingCategory)
include(ECMAddAppIcon)
include(ECMSetupVersion)
include(ECMAddTests)
include(GenerateExportHeader)
include(KDEGitCommitHooks)
include(KDEClangFormat)
include(ECMDeprecationSettings)


if (QT_MAJOR_VERSION STREQUAL "6")
    set(QT_MIN_VERSION "6.4.0")
    set(KF_MIN_VERSION "5.240.0")
    set(KF_MAJOR_VERSION "6")
else()
    set(KF_MAJOR_VERSION "5")
endif()

set (CMAKE_CXX_STANDARD 17)

find_package(
    Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION}
    CONFIG REQUIRED
        Core
        Gui
        Widgets
        Concurrent
)

find_package(
    Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION}
    QUIET CONFIG OPTIONAL_COMPONENTS
        Charts
)

find_package(
    KF${KF_MAJOR_VERSION} ${KF_MIN_VERSION}
    REQUIRED COMPONENTS
        ConfigWidgets
        CoreAddons
        Crash
        DocTools
        I18n
        XmlGui
        KIO
        TextWidgets
        TextEditor
        SyntaxHighlighting
)

if (NOT WIN32 AND NOT APPLE)
    find_package(KF${KF_MAJOR_VERSION}DBusAddons ${KF_MIN_VERSION} CONFIG REQUIRED)
    set(HAVE_KDBUSADDONS true)
endif()

find_package(DolphinVcs)
set_package_properties(DolphinVcs PROPERTIES
    TYPE OPTIONAL
    PURPOSE "Required for building dolphin plugins"
    DESCRIPTION "Use for building dolphin plugin"
)

add_definitions(-DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT)
add_definitions(-DQT_NO_CAST_TO_ASCII)
add_definitions(-DQT_NO_URL_CAST_FROM_STRING)
add_definitions(-DQT_NO_CAST_FROM_BYTEARRAY)
add_definitions(-DQT_NO_FOREACH)
add_definitions(-DQT_NO_CONTEXTLESS_CONNECT)
#add_definitions(-DQT_NO_CAST_FROM_ASCII)

configure_file(config-kommit.h.in ${CMAKE_CURRENT_BINARY_DIR}/config-kommit.h)

ecm_set_disabled_deprecation_versions(QT 5.15.2 KF 6.3)

option(USE_UNITY_CMAKE_SUPPORT "Use UNITY cmake support (speedup compile time)" OFF)

set(COMPILE_WITH_UNITY_CMAKE_SUPPORT OFF)
if (USE_UNITY_CMAKE_SUPPORT)
    set(COMPILE_WITH_UNITY_CMAKE_SUPPORT ON)
endif()

if(BUILD_TESTING)
    find_package(Qt${QT_MAJOR_VERSION} ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Test)
    add_definitions(-DBUILD_TESTING)
endif(BUILD_TESTING)


kdoctools_install(po)

add_subdirectory(icons)
add_subdirectory(src)
#add_subdirectory(autotests)
if (UNIX AND TARGET DolphinVcs)
    add_subdirectory(dolphinplugins)
endif ()


ecm_qt_install_logging_categories(
    EXPORT KOMMIT
    FILE kommit.categories
    DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR}
)

if (KOMMIT_BUILD_DIR)
    file(WRITE ${KOMMIT_BUILD_DIR}/version "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
    message("-- Version in file ${KOMMIT_BUILD_DIR}/version saved")
endif()

kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)
ki18n_install(po)

#CPack
set(CPACK_PACKAGE_NAME ${PROJECT_NAME}
    CACHE STRING "The resulting package name"
)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "KDE git gui client"
    CACHE STRING "Package description for the package metadata"
)
set(CPACK_PACKAGE_VENDOR "KDE")
set(CPACK_VERBATIM_VARIABLES YES)
set(CPACK_PACKAGE_INSTALL_DIRECTORY ${CPACK_PACKAGE_NAME})
#SET(CPACK_OUTPUT_FILE_PREFIX "${CMAKE_SOURCE_DIR}/_packages")

# https://unix.stackexchange.com/a/11552/254512
#set(CPACK_PACKAGING_INSTALL_PREFIX "/opt/some")#/${CMAKE_PROJECT_VERSION}")

set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VERSION_PATCH})
set(CPACK_PACKAGE_DESCRIPTION   "Git client for KDE")

set(CPACK_PACKAGE_CONTACT "hamed.masafi@gmail.com")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Hamed Masafi")

set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
#set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README.md")

if (KOMMIT_BUILD_DIR)
    set(CPACK_PACKAGE_FILE_NAME "kommit")
else()
    set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
endif()

set(CPACK_COMPONENTS_GROUPING ONE_PER_GROUP)
# without this you won't be able to pack only specified component
set(CPACK_DEB_COMPONENT_INSTALL YES)
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
add_subdirectory(libkommit)
add_subdirectory(libkommitwidgets)
add_subdirectory(libkommitdiff)
add_subdirectory(data)
add_subdirectory(gui)
add_subdirectory(apps)

=== dolphinplugins/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Hamed Masafi <hamed.masafi@gmail.com>
# SPDX-License-Identifier: BSD-3-Clause

macro(add_dolphinplugins_test _source)
    set( _test ${_source} gittestmanager.cpp gittestmanager.h ../statuscache.cpp ../manager.cpp ../dolphinplugin.cpp ../dolphinplugin.h)
    get_filename_component( _name ${_source} NAME_WE )
    add_executable( ${_name} ${_test} ${ARGN} ${_name}.h)
    add_test(NAME ${_name} COMMAND ${_name} )
    ecm_mark_as_test(${_name})
    target_link_libraries( ${_name} Qt::Test libkommitgui DolphinVcs PkgConfig::LIBGIT2)
endmacro()

add_dolphinplugins_test(overlaytest.cpp)

=== src/data/CMakeLists.txt ===
install(PROGRAMS kommitdiff.sh DESTINATION bin RENAME kommitdiff)
install(PROGRAMS kommitmerge.sh DESTINATION bin RENAME kommitmerge)
install(PROGRAMS org.kde.kommit.desktop        DESTINATION ${KDE_INSTALL_APPDIR})
install(PROGRAMS org.kde.kommit.diff.desktop   DESTINATION ${KDE_INSTALL_APPDIR})
install(PROGRAMS org.kde.kommit.merge.desktop  DESTINATION ${KDE_INSTALL_APPDIR})
install(FILES org.kde.kommit.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})

=== src/gui/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/core)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(libkommitgui SHARED)
generate_export_header(libkommitgui BASE_NAME libkommitgui)
target_sources(libkommitgui PRIVATE
    core/listview.cpp
    core/listview.h
    core/pushbutton.cpp
    core/pushbutton.h
    core/treeview.cpp
    core/treeview.h
    core/kmessageboxhelper.h
    core/kmessageboxhelper.cpp
    core/repositorydata.h
    core/repositorydata.cpp

    models/commitsfiltermodel.cpp
    models/commitsfiltermodel.h
    pages/reportswidget.h
    pages/reportswidget.cpp
    pages/branchesstatuswidget.h
    pages/branchesstatuswidget.cpp
    pages/commitswidget.h
    pages/commitswidget.cpp
    pages/historyviewwidget.h
    pages/historyviewwidget.cpp
    pages/remoteswidget.h
    pages/remoteswidget.cpp
    pages/stasheswidget.h
    pages/stasheswidget.cpp
    pages/submoduleswidget.h
    pages/submoduleswidget.cpp
    pages/tagswidget.h
    pages/tagswidget.cpp
    pages/widgetbase.h
    pages/widgetbase.cpp

    appwindow.cpp
    buttonsgroup.cpp
    multipagewidget.cpp


    commandargsparser.cpp
    appconfig.cpp
    settings/settingsmanager.cpp
    appwindow.h
    buttonsgroup.h
    multipagewidget.h


    commandargsparser.h
    appconfig.h
    settings/settingsmanager.h
    kommit.qrc
    icons/icons.qrc

    pages/reportswidget.h
    pages/reportswidget.cpp
)

set_target_properties(libkommitgui
    PROPERTIES OUTPUT_NAME kommitgui VERSION ${LIBKOMMIT_LIB_VERSION} SOVERSION ${LIBKOMMIT_LIB_SOVERSION}
)

add_compile_definitions(LIBKOMMIT_WIDGET_USE_KF)

install(TARGETS libkommitgui ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)

ecm_qt_declare_logging_category(libkommitgui
    HEADER kommit_appdebug.h
    IDENTIFIER KOMMIT_LOG
    CATEGORY_NAME "org.kde.kommit" DESCRIPTION "kommit" EXPORT KOMMIT
)

kconfig_add_kcfg_files(libkommitgui settings/KommitSettings.kcfgc)

add_compile_definitions(GIT_GUI)

ki18n_wrap_ui(
    libkommitgui

    settings/settingspagebase.ui
    settings/settingspagediff.ui
    settings/settingspagegit.ui
    multipagewidget.ui
    kommitmergeview.ui
    commandpullwidget.ui

    pages/reportswidget.ui
    pages/branchesstatuswidget.ui
    pages/commitswidget.ui
    pages/historyviewwidget.ui
    pages/remoteswidget.ui
    pages/stasheswidget.ui
    pages/submoduleswidget.ui
    pages/tagswidget.ui
    pages/reportswidget.ui
)

target_link_libraries(libkommitgui
    Qt::Core
    Qt::Widgets
    Qt::Concurrent
    Qt::Network

    libkommit
    libkommitdiff
    libkommitwidgets

    KF${KF_MAJOR_VERSION}::CoreAddons
    KF${KF_MAJOR_VERSION}::I18n
    KF${KF_MAJOR_VERSION}::XmlGui
    KF${KF_MAJOR_VERSION}::ConfigWidgets
    KF${KF_MAJOR_VERSION}::Crash
    KF${KF_MAJOR_VERSION}::KIOCore
    KF${KF_MAJOR_VERSION}::KIOFileWidgets
    KF${KF_MAJOR_VERSION}::KIOWidgets
    KF${KF_MAJOR_VERSION}::Parts
    KF${KF_MAJOR_VERSION}::TextWidgets
    KF${KF_MAJOR_VERSION}::TextEditor

    KF${KF_MAJOR_VERSION}::SyntaxHighlighting
)

if (TARGET KF${KF_MAJOR_VERSION}::DBusAddons)
    target_link_libraries(libkommitgui KF${KF_MAJOR_VERSION}::DBusAddons)
endif()	

if (COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(libkommitgui PROPERTIES UNITY_BUILD ON)
endif()


set_target_properties(
    libkommitgui PROPERTIES
    MACOSX_BUNDLE_GUI_IDENTIFIER org.kde.kommit
    MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
    MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
    MACOSX_BUNDLE TRUE
    WIN32_EXECUTABLE TRUE
)

if (BUILD_TESTING)
    add_subdirectory(autotests)
endif()

=== src/libkommit/CMakeLists.txt ===
add_library(libkommit SHARED)

set(SOURCES
    gitglobal.cpp
    gitloglist.cpp
    filestatus.cpp
    gitgraphlane.cpp
    gitmanager.cpp
    blamedata.cpp
    types.cpp
    abstractreference.cpp

    models/abstractgititemsmodel.cpp
    models/logsmodel.cpp
    models/remotesmodel.cpp
    models/submodulesmodel.cpp
    models/branchesmodel.cpp
    models/stashesmodel.cpp
    models/tagsmodel.cpp


    commands/abstractcommand.cpp
    commands/commandchangedfiles.cpp
    commands/commandclone.cpp
    commands/commandcommit.cpp
    commands/commandfetch.cpp
    commands/commandpull.cpp
    commands/commandpush.cpp
    commands/commandswitchbranch.cpp
    commands/commandmerge.cpp
    commands/addsubmodulecommand.cpp
    commands/commandaddremote.cpp
    commands/parameterescommand.cpp
    commands/commandclean.cpp

    entities/branch.cpp
    entities/commit.cpp
    entities/file.cpp
    entities/note.cpp
    entities/reference.cpp
    entities/remote.cpp
    entities/signature.cpp
    entities/stash.cpp
    entities/tree.cpp
    entities/tag.cpp
    entities/submodule.cpp
    entities/index.cpp
    entities/treediff.cpp

    observers/fetchobserver.cpp
    observers/cloneobserver.cpp
    observers/checkoutobserver.cpp
    observers/pushobserver.cpp

    options/addsubmoduleoptions.cpp
    options/fetchoptions.cpp
    options/checkoutoptions.cpp
)
set(HEADERS
    gitglobal.h
    gitloglist.h
    filestatus.h
    gitgraphlane.h
    gitmanager.h
    blamedata.h
    types.h
    abstractreference.h

    models/abstractgititemsmodel.h
    models/logsmodel.h
    models/remotesmodel.h
    models/submodulesmodel.h
    models/branchesmodel.h
    models/stashesmodel.h
    models/tagsmodel.h


    commands/abstractcommand.h
    commands/commandchangedfiles.h
    commands/commandclone.h
    commands/commandcommit.h
    commands/commandfetch.h
    commands/commandpull.h
    commands/commandpush.h
    commands/commandswitchbranch.h
    commands/commandmerge.h
    commands/addsubmodulecommand.h
    commands/commandaddremote.h
    commands/parameterescommand.h
    commands/commandclean.h
    commands/addsubmodulecommand.h

    entities/branch.h
    entities/commit.h
    entities/file.h
    entities/note.h
    entities/reference.h
    entities/remote.h
    entities/signature.h
    entities/stash.h
    entities/tree.h
    entities/tag.h
    entities/submodule.h
    entities/treediff.h
    entities/index.h

    observers/fetchobserver.h
    observers/cloneobserver.h
    observers/checkoutobserver.h
    observers/pushobserver.h

    options/addsubmoduleoptions.h
    options/fetchoptions.h
    options/checkoutoptions.h
)
target_sources(libkommit PRIVATE ${SOURCES} ${HEADERS})
# target_sources(libkommit
#     PUBLIC FILE_SET HEADERS
#     BASE_DIRS ${MY_LIB_SOURCE_DIR}
#     FILES ${HEADERS}
# )

generate_export_header(libkommit BASE_NAME libkommit)

ecm_qt_declare_logging_category(libkommit
    HEADER libkommit_debug.h
    IDENTIFIER KOMMITLIB_LOG
    CATEGORY_NAME "org.kde.kommit.libkommit" DESCRIPTION "libkommit" EXPORT KOMMIT
)

set_target_properties(libkommit
    PROPERTIES OUTPUT_NAME kommit VERSION ${LIBKOMMIT_LIB_VERSION} SOVERSION ${LIBKOMMIT_LIB_SOVERSION}
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include/kommit)

target_link_libraries(libkommit
    PkgConfig::LIBGIT2
    Qt::Core
    Qt::Widgets
    Qt::Concurrent
    KF${KF_MAJOR_VERSION}::I18n
)

if (BUILD_TESTING)
    add_subdirectory(autotests)
endif()

install(TARGETS libkommit ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)
# install(FILES ${HEADERS} DESTINATION include/kommit) future releases

=== src/libkommitwidgets/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(libkommitwidgets SHARED)

generate_export_header(libkommitwidgets BASE_NAME libkommitwidgets)

target_sources(libkommitwidgets PRIVATE
    kommitwidgetsglobaloptions.h 
    kommitwidgetsglobaloptions.cpp

    widgets/reportwidget.h
    widgets/graphpainter.cpp
    widgets/segmentsscrollbar.cpp
    widgets/difftreeview.h
    widgets/filesstatuseslist.h
    widgets/commitdetails.cpp
    widgets/avatarview.h
    widgets/codeeditor.cpp
    widgets/segmentsmapper.h
    widgets/segmentsscrollbar.h
    widgets/reportwidget.cpp
    widgets/codeeditorsidebar.h
    widgets/segmentsmapper.cpp
    widgets/segmentconnector.h
    widgets/diffwidget.h
    widgets/avatarview.cpp
    widgets/codeeditorsidebar.cpp
    widgets/codeeditor.h
    widgets/blamecodeview.h
    widgets/completiontextedit.cpp
    widgets/completiontextedit.h
    widgets/graphpainter.h
    widgets/segmentconnector.cpp
    widgets/blamecodeview.cpp
    widgets/diffwidget.cpp
    widgets/difftreeview.cpp
    widgets/filesstatuseslist.cpp
    widgets/commitdetails.h
    widgets/urlrequester.cpp
    widgets/urlrequester.h

    core/kmessageboxhelper.h
    core/kmessageboxhelper.cpp
    core/editactionsmapper.h
    core/editactionsmapper.cpp
    core/gravatarcache.cpp
    core/gravatarcache.h

    reports/authorsreport.cpp
    reports/authorsreport.h
    reports/abstractreport.cpp
    reports/abstractreport.h
    reports/commitsbydayweek.cpp
    reports/commitsbydayweek.h
    reports/commitsbydayhour.cpp
    reports/commitsbydayhour.h
    reports/commitsbymonth.cpp
    reports/commitsbymonth.h

    windows/appmainwindow.cpp
    windows/mergewindow.h
    windows/diffwindow.h
    windows/diffwindow.cpp
    windows/mergewindow.cpp
    windows/appmainwindow.h

    actions/submoduleactions.cpp
    actions/remotesactions.h
    actions/tagsactions.cpp
    actions/branchactions.cpp
    actions/changedfileactions.h
    actions/branchactions.h
    actions/fileactions.cpp
    actions/submoduleactions.h
    actions/stashactions.h
    actions/abstractactions.cpp
    actions/abstractactions.h
    actions/fileactions.h
    actions/commitactions.cpp
    actions/changedfileactions.cpp
    actions/stashactions.cpp
    actions/commitactions.h
    actions/tagsactions.h
    actions/remotesactions.cpp

    models/treemodel.h
    models/treemodel.cpp
    models/changedfilesmodel.h
    models/difftreemodel.h
    models/difftreemodel.cpp
    models/filesmodel.cpp
    models/changedfilesmodel.cpp
    models/filesmodel.h

    dialogs/appdialog.h
    dialogs/runnerdialog.cpp
    dialogs/submoduleinfodialog.cpp
    dialogs/credentialdialog.cpp
    dialogs/taginfodialog.h
    dialogs/selectbranchestodiffdialog.h
    dialogs/selectbranchestodiffdialog.cpp
    dialogs/initdialog.h
    dialogs/changedfilesdialog.h
    dialogs/mergedialog.h
    dialogs/filehistorydialog.h
    dialogs/changedsubmodulesdialog.h
    dialogs/ignorefiledialog.cpp
    dialogs/switchbranchdialog.h
    dialogs/changedsubmodulesdialog.cpp
    dialogs/initdialog.cpp
    dialogs/cleanupdialog.h
    dialogs/ignorefiledialog.h
    dialogs/reposettingsdialog.h
    dialogs/mergeopenfilesdialog.h
    dialogs/remoteinfodialog.h
    dialogs/diffopendialog.cpp
    dialogs/fileviewerdialog.h
    dialogs/commitpushdialog.cpp
    dialogs/mergedialog.cpp
    dialogs/filestreedialog.h
    dialogs/fileblamedialog.h
    dialogs/submoduleinfodialog.h
    dialogs/changedfilesdialog.cpp
    dialogs/switchbranchdialog.cpp
    dialogs/mergecloseeventdialog.cpp
    dialogs/reposettingsdialog.cpp
    dialogs/mergecloseeventdialog.h
    dialogs/mergeopenfilesdialog.cpp
    dialogs/notedialog.h
    dialogs/remoteinfodialog.cpp
    dialogs/pulldialog.h
    dialogs/searchdialog.cpp
    dialogs/taginfodialog.cpp
    dialogs/filestreedialog.cpp
    dialogs/fetchdialog.h
    dialogs/diffopendialog.h
    dialogs/credentialdialog.h
    dialogs/fetchdialog.cpp
    dialogs/fileviewerdialog.cpp
    dialogs/cleanupdialog.cpp
    dialogs/commitpushdialog.h
    dialogs/notedialog.cpp
    dialogs/clonedialog.cpp
    dialogs/appdialog.cpp
    dialogs/runnerdialog.h
    dialogs/pulldialog.cpp
    dialogs/clonedialog.h
    dialogs/fileblamedialog.cpp
    dialogs/searchdialog.h
    dialogs/filehistorydialog.cpp

)

target_link_libraries(libkommitwidgets
    Qt::Core
    Qt::Widgets
    Qt::Concurrent
    Qt::Network

    libkommit
    libkommitdiff

    KF${KF_MAJOR_VERSION}::I18n
    KF${KF_MAJOR_VERSION}::SyntaxHighlighting
    KF${KF_MAJOR_VERSION}::XmlGui
    KF${KF_MAJOR_VERSION}::KIOWidgets
    KF${KF_MAJOR_VERSION}::Parts

)

if(TARGET Qt::Charts)
    target_link_libraries(libkommitwidgets Qt::Charts)
endif()

install(TARGETS libkommitwidgets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)

ecm_qt_declare_logging_category(libkommitwidgets
    HEADER libkommitwidgets_appdebug.h
    IDENTIFIER KOMMIT_WIDGETS_LOG
    CATEGORY_NAME "org.kde.kommit.widgets" DESCRIPTION "kommit" EXPORT KOMMIT
)

add_compile_definitions(LIBKOMMIT_WIDGET_USE_KF)

ki18n_wrap_ui(
    libkommitwidgets

    widgets/diffwidget.ui
    widgets/commitdetails.ui
    widgets/reportwidget.ui
    widgets/difftreeview.ui
    windows/kommitmergeview.ui
    dialogs/mergecloseeventdialog.ui
    dialogs/searchdialog.ui
    dialogs/credentialdialog.ui
    dialogs/submoduleinfodialog.ui
    dialogs/remoteinfodialog.ui
    dialogs/changedfilesdialog.ui
    dialogs/cleanupdialog.ui
    dialogs/clonedialog.ui
    dialogs/selectbranchestodiffdialog.ui
    dialogs/pulldialog.ui
    dialogs/diffopendialog.ui
    dialogs/runnerdialog.ui
    dialogs/fileblamedialog.ui
    dialogs/changedsubmodulesdialog.ui
    dialogs/initdialog.ui
    dialogs/switchbranchdialog.ui
    dialogs/mergeopenfilesdialog.ui
    dialogs/fileviewerdialog.ui
    dialogs/filestreedialog.ui
    dialogs/filehistorydialog.ui
    dialogs/commitpushdialog.ui
    dialogs/mergedialog.ui
    dialogs/reposettingsdialog.ui
    dialogs/fetchdialog.ui
    dialogs/ignorefiledialog.ui
    dialogs/notedialog.ui
    dialogs/taginfodialog.ui
)

if (COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(libkommitwidgets PROPERTIES UNITY_BUILD ON)
endif()

set_target_properties(libkommitwidgets
    PROPERTIES OUTPUT_NAME kommitwidgets VERSION ${LIBKOMMIT_LIB_VERSION} SOVERSION ${LIBKOMMIT_LIB_SOVERSION}
)

set_target_properties(
    libkommitwidgets PROPERTIES
    MACOSX_BUNDLE_GUI_IDENTIFIER org.kde.kommit
    MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
    MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
    MACOSX_BUNDLE TRUE
    WIN32_EXECUTABLE TRUE
)

# if (BUILD_TESTING)
#     add_subdirectory(autotests)
# endif()

=== src/libkommit/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause
macro(add_LIBKOMMIT_test _source)
    set( _test ${_source} testcommon.cpp testcommon.h)
    get_filename_component( _name ${_source} NAME_WE )
    add_executable( ${_name} ${_test} ${ARGN} ${_name}.h)
    add_test(NAME ${_name} COMMAND ${_name} )
    ecm_mark_as_test(${_name})
    target_link_libraries( ${_name} Qt::Test libkommit)
endmacro()

add_LIBKOMMIT_test(tagtest.cpp)
add_LIBKOMMIT_test(clonetest.cpp)
add_LIBKOMMIT_test(indextest.cpp)
add_LIBKOMMIT_test(clonecommandtest.cpp)
add_LIBKOMMIT_test(commandcleantest.cpp)
add_LIBKOMMIT_test(commandpushtest.cpp)
add_LIBKOMMIT_test(addsubmodulecommandtest.cpp)
add_LIBKOMMIT_test(branchestest.cpp)
add_LIBKOMMIT_test(configtest.cpp)
add_LIBKOMMIT_test(remotetest.cpp)
add_LIBKOMMIT_test(stashtest.cpp)
add_LIBKOMMIT_test(submoduletest.cpp)
add_LIBKOMMIT_test(filetest.cpp)
add_LIBKOMMIT_test(branchesdifftest.cpp)

=== debian/changelog ===
kommit (1.6.0+p24.04+vstable+git20250927.0010-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 27 Sep 2025 00:10:25 +0000

kommit (1.6.0-0neon) noble; urgency=medium

  * initial release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Wed, 12 Apr 2023 17:36:22 +1000

kommit (0.4.0-0neon) jammy; urgency=medium

  * initial packaging

 -- Carlos De Maine <carlosdemaine@gmail.com>  Fri, 16 Dec 2022 08:23:15 +0100

## kommit 1.6.0+p24.04+vstable+git20250930.0455

=== debian/changelog ===
kommit (1.6.0+p24.04+vstable+git20250930.0455-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 30 Sep 2025 04:55:41 +0000

## kommit 1.6.0+p24.04+vstable+git20251015.1634

=== debian/changelog ===
kommit (1.6.0+p24.04+vstable+git20251015.1634-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 15 Oct 2025 16:34:23 +0000

=== debian/control ===
Source: kommit
Section: utils
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               kf6-extra-cmake-modules,
               kf6-kconfigwidgets-dev,
               kf6-kcoreaddons-dev,
               kf6-kdbusaddons-dev,
               kf6-kdoctools-dev,
               kf6-ki18n-dev,
               kf6-kio-dev,
               kf6-ktexteditor-dev,
               kf6-ktextwidgets-dev,
               kf6-kxmlgui-dev,
               kf6-syntax-highlighting-dev,
               libdolphinvcs-dev,
               libgit2-dev,
               pkg-kde-tools-neon,
               qt6-base,
               qt6-charts-dev
Standards-Version: 4.6.2
Homepage: https://invent.kde.org/sdk/kommit
Vcs-Git: https://invent.kde.org/neon/neon-packaging/kommit.git
Vcs-Browser: https://invent.kde.org/neon/neon-packaging/kommit
Maintainer: Neon CI <neon@kde.org>

Package: kommit
Architecture: any
Multi-Arch: same
Depends: git, ${misc:Depends}, ${shlibs:Depends}
Replaces: gitklient
Breaks: gitklient
Description: Git repo management tool
 .
 Kommit is an application by KDE for interacting with Git version
 control repositories.

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ http://download.kde.org/stable/@PACKAGE@/@PACKAGE@-([\d.]+).tar.xz

## kommit 1.6.0+p24.04+vstable+git20251019.0617

=== debian/changelog ===
kommit (1.6.0+p24.04+vstable+git20251019.0617-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 19 Oct 2025 06:17:47 +0000

## kommit 1.6.0+p24.04+vstable+git20251028.0303

=== debian/changelog ===
kommit (1.6.0+p24.04+vstable+git20251028.0303-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 28 Oct 2025 03:03:43 +0000

## kommit 1.6.0+p24.04+vstable+git20251201.0147

=== debian/changelog ===
kommit (1.6.0+p24.04+vstable+git20251201.0147-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 01 Dec 2025 01:47:56 +0000

## kommit 1.6.0+p24.04+vstable+git20251231.0508

=== debian/changelog ===
kommit (1.6.0+p24.04+vstable+git20251231.0508-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 31 Dec 2025 05:08:54 +0000

## kommit 1.6.0+p24.04+vunstable+git20251009.0706

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(kommit)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

set(PROJECT_VERSION_MAJOR 1)
set(PROJECT_VERSION_MINOR 6)
set(PROJECT_VERSION_PATCH 43)

set(RELEASE_SERVICE_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")

set(LIBKOMMIT_LIB_VERSION "${RELEASE_SERVICE_VERSION}")
set(LIBKOMMIT_LIB_SOVERSION "0")

set(QT_MIN_VERSION 5.15.2)
set(KF_MIN_VERSION 5.90.0)
set(KDE_COMPILERSETTINGS_LEVEL "5.82")

add_definitions(-DGK_VERSION="${RELEASE_SERVICE_VERSION}")

find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)
find_package(OpenSSL OPTIONAL_COMPONENTS Crypto SSL)

set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(FeatureSummary)
include(GenerateExportHeader)
include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings NO_POLICY_SCOPE)
include(KDEGitCommitHooks)
include(KDEClangFormat)
include(ECMInstallIcons)
include(ECMQtDeclareLoggingCategory)
include(ECMAddAppIcon)
include(ECMSetupVersion)
include(ECMAddTests)
include(ECMDeprecationSettings)
include(ECMGenerateHeaders)
include(ECMGenerateExportHeader)

option(BUILD_DOC "Whether to build the documentation" ON)

if (NOT LIBGIT2_FOUND)
    message("libgit2 not found")
endif()

if(QT_MAJOR_VERSION STREQUAL "6")
    set(QT_MIN_VERSION "6.4.0")
    set(KF_MIN_VERSION "6.3.0")
    set(KF_MAJOR_VERSION "6")
else()
    set(KF_MAJOR_VERSION "5")
endif()

set(CMAKE_CXX_STANDARD 17)

find_package(
    Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION}
    CONFIG REQUIRED
        Core
        Gui
        Widgets
        Concurrent
)

find_package(
    Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION}
    QUIET CONFIG OPTIONAL_COMPONENTS
        Charts
)

find_package(
    KF${KF_MAJOR_VERSION} ${KF_MIN_VERSION}
    REQUIRED COMPONENTS
        ConfigWidgets
        CoreAddons
        Crash
        I18n
        XmlGui
        KIO
        TextWidgets
        TextEditor
        SyntaxHighlighting
)
find_package(Libgit2 REQUIRED)

if(NOT WIN32 AND NOT APPLE AND NOT HAIKU)
    find_package(KF${KF_MAJOR_VERSION}DBusAddons ${KF_MIN_VERSION} CONFIG REQUIRED)
    set(HAVE_KDBUSADDONS true)
endif()

if(BUILD_DOC)
    find_package(KF${KF_MAJOR_VERSION}DocTools ${KF_MIN_VERSION})
    set_package_properties(KF${KF_MAJOR_VERSION}DocTools PROPERTIES
        DESCRIPTION "Tools to generate documentation"
        TYPE REQUIRED
    )
endif()

find_package(DolphinVcs)
set_package_properties(DolphinVcs PROPERTIES
    TYPE OPTIONAL
    PURPOSE "Required for building dolphin plugins"
    DESCRIPTION "Use for building dolphin plugin"
)

add_definitions(-DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT)
add_definitions(-DQT_NO_CAST_TO_ASCII)
add_definitions(-DQT_NO_URL_CAST_FROM_STRING)
add_definitions(-DQT_NO_CAST_FROM_BYTEARRAY)
add_definitions(-DQT_NO_FOREACH)
add_definitions(-DQT_NO_CONTEXTLESS_CONNECT)
#add_definitions(-DQT_NO_CAST_FROM_ASCII)

configure_file(config-kommit.h.in ${CMAKE_CURRENT_BINARY_DIR}/config-kommit.h)

ecm_set_disabled_deprecation_versions(QT 5.15.2 KF 6.5)

option(USE_UNITY_CMAKE_SUPPORT "Use UNITY cmake support (speedup compile time)" OFF)

set(COMPILE_WITH_UNITY_CMAKE_SUPPORT OFF)
if(USE_UNITY_CMAKE_SUPPORT)
    set(COMPILE_WITH_UNITY_CMAKE_SUPPORT ON)
endif()

if(BUILD_TESTING)
    find_package(Qt${QT_MAJOR_VERSION} ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Test)
    add_definitions(-DBUILD_TESTING)
endif()

if(BUILD_DOC)
    kdoctools_install(po)
endif()

add_subdirectory(icons)
add_subdirectory(src)
if(UNIX AND TARGET DolphinVcs)
    add_subdirectory(dolphinplugins)
endif()


ecm_qt_install_logging_categories(
    EXPORT KOMMIT
    FILE kommit.categories
    DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR}
)

if(KOMMIT_BUILD_DIR)
    file(WRITE ${KOMMIT_BUILD_DIR}/version "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
    message("-- Version in file ${KOMMIT_BUILD_DIR}/version saved")
endif()

kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)
ki18n_install(po)

#CPack
set(CPACK_PACKAGE_NAME ${PROJECT_NAME}
    CACHE STRING "The resulting package name"
)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "KDE git gui client"
    CACHE STRING "Package description for the package metadata"
)
set(CPACK_PACKAGE_VENDOR "KDE")
set(CPACK_VERBATIM_VARIABLES YES)
set(CPACK_PACKAGE_INSTALL_DIRECTORY ${CPACK_PACKAGE_NAME})

set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VERSION_PATCH})
set(CPACK_PACKAGE_DESCRIPTION   "Git client for KDE")

set(CPACK_PACKAGE_CONTACT "hamed.masafi@gmail.com")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Hamed Masafi")

set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")

if(KOMMIT_BUILD_DIR)
    set(CPACK_PACKAGE_FILE_NAME "kommit")
else()
    set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
endif()

set(CPACK_COMPONENTS_GROUPING ONE_PER_GROUP)
# without this you won't be able to pack only specified component
set(CPACK_DEB_COMPONENT_INSTALL YES)
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== dolphinplugins/CMakeLists.txt ===
find_package(KF${KF_MAJOR_VERSION} ${KF${KF_MAJOR_VERSION}_MIN_VERSION} REQUIRED COMPONENTS KIO)

set(GIT_EXTRA_SOURCE
)

ecm_qt_declare_logging_category(
    GIT_EXTRA_SOURCE
    HEADER kommit_dolphinplugins_debug.h
    IDENTIFIER KOMMIT_DOLPHIN_PLUGINS_LOG
    CATEGORY_NAME org.kde.kommit.dolphinplugins
    DESCRIPTION "kommit dolphin plugins"
    EXPORT kommit
)

#--- VCS Plugin ---
add_definitions(-DTRANSLATION_DOMAIN=\"fileviewgitplugin\")

kcoreaddons_add_plugin(kommitdolphinplugin INSTALL_NAMESPACE "dolphin/vcs")

target_sources(kommitdolphinplugin PRIVATE
    dolphinplugin.h dolphinplugin.cpp
    statuscache.h statuscache.cpp
)

target_link_libraries(kommitdolphinplugin PRIVATE
    Qt::Core
    Qt::Widgets
    KF${KF_MAJOR_VERSION}::I18n
    KF${QT_MAJOR_VERSION}::KIOCore
    DolphinVcs
    Libgit2
)

#install(FILES fileviewgitpluginsettings.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

if(BUILD_TESTING)
    add_subdirectory(autotests)
endif()

=== dolphinplugins/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Hamed Masafi <hamed.masafi@gmail.com>
# SPDX-License-Identifier: BSD-3-Clause

macro(add_dolphinplugins_test _source)
    set(_test ${_source} gittestmanager.cpp gittestmanager.h ../statuscache.cpp ../manager.cpp ../dolphinplugin.cpp ../dolphinplugin.h)
    get_filename_component(_name ${_source} NAME_WE)
    add_executable(${_name} ${_test} ${ARGN} ${_name}.h)
    add_test(NAME ${_name} COMMAND ${_name})
    ecm_mark_as_test(${_name})
    target_link_libraries(${_name} Qt::Test libkommitgui DolphinVcs Libgit2)
endmacro()

add_dolphinplugins_test(overlaytest.cpp)

=== src/data/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,5 @@
+# SPDX-FileCopyrightText: none
+# SPDX-License-Identifier: BSD-3-Clause
 install(PROGRAMS kommitdiff.sh DESTINATION bin RENAME kommitdiff)
 install(PROGRAMS kommitmerge.sh DESTINATION bin RENAME kommitmerge)
 install(PROGRAMS org.kde.kommit.desktop        DESTINATION ${KDE_INSTALL_APPDIR})

=== src/libkommit/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
add_library(libkommit SHARED)

set(KOMMIT_INSTALL_INCLUDEDIR "${KDE_INSTALL_INCLUDEDIR}/Kommit")
set(KOMMIT_CMAKECONFIG_NAME "Kommit")

ecm_setup_version(1.0.0
    VARIABLE_PREFIX      LIBKOMMIT
    VERSION_HEADER       "libkommit_version.h"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/${KOMMIT_CMAKECONFIG_NAME}ConfigVersion.cmake"
    COMPATIBILITY        SameMajorVersion
    SOVERSION            1
)

target_sources(libkommit PRIVATE
    libkommit_global.h

    gitglobal.cpp gitglobal.h
    gitloglist.cpp gitloglist.h
    filestatus.cpp filestatus.h
    repository.cpp repository.h
    types.cpp
    abstractreference.cpp abstractreference.h
    buffer.cpp buffer.h
    credential.cpp credential.h
    entities/blob.h entities/blob.cpp
    config.h config.cpp
    filedelta.h filedelta.cpp
    filemode.h filemode.cpp
    refspec.h refspec.cpp
    itree.h
    ioid.h
    blame.h blame.cpp
    blamehunk.h blamehunk.cpp
    fetch.h fetch.cpp
    certificate.h certificate.cpp
    error.h error.cpp
    remotecallbacks.h remotecallbacks.cpp
    proxy.cpp proxy.h
    clone.h clone.cpp

    caches/abstractcache.cpp caches/abstractcache.h
    caches/branchescache.cpp caches/branchescache.h
    caches/commitscache.cpp caches/commitscache.h
    caches/remotescache.cpp caches/remotescache.h
    caches/tagscache.cpp caches/tagscache.h
    caches/notescache.cpp caches/notescache.h
    caches/stashescache.cpp caches/stashescache.h
    caches/submodulescache.cpp caches/submodulescache.h
    caches/referencecache.cpp caches/referencecache.h

    commands/abstractcommand.cpp commands/abstractcommand.h
    commands/commandchangedfiles.cpp commands/commandchangedfiles.h
    commands/commandclone.cpp commands/commandclone.h
    commands/commandcommit.cpp commands/commandcommit.h
    commands/commandfetch.cpp commands/commandfetch.h
    commands/commandpull.cpp commands/commandpull.h
    commands/commandpush.cpp commands/commandpush.h
    commands/commandswitchbranch.cpp commands/commandswitchbranch.h
    commands/commandmerge.cpp commands/commandmerge.h
    commands/addsubmodulecommand.cpp commands/addsubmodulecommand.h
    commands/commandaddremote.cpp commands/commandaddremote.h
    commands/parameterescommand.cpp commands/parameterescommand.h
    commands/commandclean.cpp commands/commandclean.h

    entities/branch.cpp
    entities/commit.cpp
    entities/file.cpp entities/file.h
    entities/note.cpp entities/note.h
    entities/reference.cpp
    entities/remote.cpp
    entities/signature.cpp entities/signature.h
    entities/stash.cpp entities/stash.h
    entities/tree.cpp
    entities/tag.cpp entities/tag.h
    entities/submodule.cpp entities/submodule.h
    entities/index.cpp entities/index.h
    entities/treediff.cpp entities/treediff.h
    entities/oid.h
    entities/oid.cpp
    entities/object.h
    entities/object.cpp
    entities/strarray.h entities/strarray.cpp

    observers/fetchobserver.cpp observers/fetchobserver.h
    observers/cloneobserver.cpp observers/cloneobserver.h
    observers/pushobserver.cpp observers/pushobserver.h

    options/addsubmoduleoptions.cpp options/addsubmoduleoptions.h
    options/fetchoptions.cpp options/fetchoptions.h
    options/checkoutoptions.cpp options/checkoutoptions.h
    options/blameoptions.h options/blameoptions.cpp
)

generate_export_header(libkommit BASE_NAME libkommit)

ecm_qt_declare_logging_category(libkommit
    HEADER libkommit_debug.h
    IDENTIFIER KOMMITLIB_LOG
    CATEGORY_NAME "org.kde.kommit.libkommit" DESCRIPTION "libkommit" EXPORT KOMMIT
)

ecm_generate_export_header(libkommit
    VERSION ${LIBKOMMIT_VERSION}
    DEPRECATED_BASE_VERSION 0
    DEPRECATION_VERSIONS
    EXCLUDE_DEPRECATED_BEFORE_AND_AT ${EXCLUDE_DEPRECATED_BEFORE_AND_AT}
    USE_VERSION_HEADER
)

set_target_properties(libkommit PROPERTIES
    VERSION     ${KOMMIT_VERSION}
    SOVERSION   ${KOMMIT_SOVERSION}
    EXPORT_NAME "Kommit"
)

set_target_properties(libkommit
    PROPERTIES OUTPUT_NAME kommit VERSION ${LIBKOMMIT_LIB_VERSION} SOVERSION ${LIBKOMMIT_LIB_SOVERSION}
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include/kommit)
target_include_directories(libkommit
    INTERFACE
        "$<INSTALL_INTERFACE:${KOMMIT_INSTALL_INCLUDEDIR}>"
)

target_include_directories(libkommit PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/entities>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/options>
)

target_link_libraries(libkommit
    Qt::Core
    Libgit2
    KF${KF_MAJOR_VERSION}::I18n
)

if (OpenSSL_FOUND)
    message(STATUS "OpenSSL found: ${OpenSSL_VERSION}")
    add_definitions(-DLIBKOMMIT_USE_OPENSSL)
    target_link_libraries(libkommit OpenSSL::SSL OpenSSL::Crypto)
else()
    message(STATUS "OpenSSL not found, building without OpenSSL support")
endif()


if(BUILD_TESTING)
    add_subdirectory(autotests)
endif()

# root folder
ecm_generate_headers(libkommit_CamelCase_HEADERS
    HEADER_NAMES
        Clone
        Repository

        Blame
        BlameHunk
        Fetch
        # BlameDataRow

        # ConfigEntry
        Config

        # ITree
        # IOid
        AbstractReference

        Buffer
        Credential
        Certificate
        FileStatus
        Types
        Error
        FileDelta
        FileMode
        Proxy
        RefSpec
        ITree
        IOid
        RemoteCallbacks
    PREFIX Kommit
    REQUIRED_HEADERS kommit_HEADERS
)

# entities sub folder
ecm_generate_headers(libkommit_CamelCase_HEADERS
    HEADER_NAMES
        Blob
        Branch
        Commit
        File
        Index
        Note
        Object
        Oid
        Reference
        Remote
        Signature
        Stash
        StrArray
        SubModule
        Tag
        Tree
        TreeDiff
    PREFIX Kommit
    REQUIRED_HEADERS kommit_HEADERS
    RELATIVE
        entities
)

# commands sub folder
ecm_generate_headers(libkommit_CamelCase_HEADERS
    HEADER_NAMES
        AbstractCommand
        ParameteresCommand
        AddSubmoduleCommand
        CommandSwitchBranch
        CommandMerge
        CommandChangedFiles
        CommandPush
        CommandPull
        CommandFetch
        CommandCommit
        CommandClone
        CommandClean
        CommandAddRemote
    PREFIX Kommit
    REQUIRED_HEADERS kommit_HEADERS
    RELATIVE
        commands
)

# caches sub folder
ecm_generate_headers(libkommit_CamelCase_HEADERS
    HEADER_NAMES
        TagsCache
        SubmodulesCache
        StashesCache
        RemotesCache
        ReferenceCache
        NotesCache
        CommitsCache
        BranchesCache
        AbstractCache
    PREFIX Kommit
    REQUIRED_HEADERS kommit_HEADERS
    RELATIVE
        caches
)

# observers sub folder
ecm_generate_headers(libkommit_CamelCase_HEADERS
    HEADER_NAMES
        FetchObserver
        PushObserver
        CloneObserver
    PREFIX Kommit
    REQUIRED_HEADERS kommit_HEADERS
    RELATIVE
        observers
)

install(
    FILES
        ${libkommit_CamelCase_HEADERS}
        ${CMAKE_CURRENT_BINARY_DIR}/libkommit_export.h
        ${CMAKE_CURRENT_SOURCE_DIR}/libkommit_global.h
        ${CMAKE_CURRENT_BINARY_DIR}/libkommit_version.h
    DESTINATION
        ${KOMMIT_INSTALL_INCLUDEDIR}/Kommit
    COMPONENT
        Devel
)

install(
    FILES
        ${kommit_HEADERS}
        ${CMAKE_CURRENT_BINARY_DIR}/libkommit_export.h
        ${CMAKE_CURRENT_SOURCE_DIR}/libkommit_global.h
        ${CMAKE_CURRENT_BINARY_DIR}/libkommit_version.h
    DESTINATION
        ${KOMMIT_INSTALL_INCLUDEDIR}/kommit
    COMPONENT
        Devel
)


install(TARGETS libkommit ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)
# install(FILES ${HEADERS} DESTINATION include/kommit) future releases

=== src/libkommitdiff/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
add_library(libkommitdiff SHARED)

target_sources(
    libkommitdiff
    PRIVATE
    diff.cpp
    diff.h
    results.cpp
    results.h
    types.h
    segments.h
    segments.cpp
    text.h
    text.cpp
    array.h
    array.cpp
    pair.h
    pair.cpp
    solution.h
    solution.cpp
    lcs.h
    lcs.cpp

    diff2.h diff2.cpp
    diff3.h diff3.cpp
    hunk.h hunk.cpp
)

generate_export_header(libkommitdiff BASE_NAME libkommitdiff)

ecm_qt_declare_logging_category(libkommitdiff
    HEADER libkommitdiff_debug.h
    IDENTIFIER KOMMITDIFFLIB_LOG
    CATEGORY_NAME "org.kde.kommit.libkommitdiff" DESCRIPTION "libkommitdiff" EXPORT KOMMIT
)

ecm_generate_headers(libkommitdiff_CamelCase_HEADERS
    HEADER_NAMES
        Diff
        Diff2
        Diff3
        Hunk
    PREFIX KommitDiff
    REQUIRED_HEADERS kommitdiff_HEADERS
)

set_target_properties(libkommitdiff
    PROPERTIES OUTPUT_NAME kommitdiff VERSION ${LIBKOMMIT_LIB_VERSION} SOVERSION ${LIBKOMMIT_LIB_SOVERSION}
)

target_link_libraries(libkommitdiff
    Qt::Core
)

install(
    TARGETS libkommitdiff ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}
    LIBRARY NAMELINK_SKIP
)

if(BUILD_TESTING)
    add_subdirectory(autotests)
endif()

=== src/libkommit/commands/CMakeLists.txt ===
set(
    GIT_SOURCE
    ${GIT_SOURCE}

    ${CMAKE_CURRENT_LIST_DIR}/abstractcommand.cpp ${CMAKE_CURRENT_LIST_DIR}/abstractcommand.h
    ${CMAKE_CURRENT_LIST_DIR}/commandchangedfiles.cpp ${CMAKE_CURRENT_LIST_DIR}/commandchangedfiles.h
    ${CMAKE_CURRENT_LIST_DIR}/commandclone.cpp ${CMAKE_CURRENT_LIST_DIR}/commandclone.h
    ${CMAKE_CURRENT_LIST_DIR}/commandcommit.cpp ${CMAKE_CURRENT_LIST_DIR}/commandcommit.h
    ${CMAKE_CURRENT_LIST_DIR}/commandfetch.cpp ${CMAKE_CURRENT_LIST_DIR}/commandfetch.h
    ${CMAKE_CURRENT_LIST_DIR}/commandpull.cpp ${CMAKE_CURRENT_LIST_DIR}/commandpull.h
    ${CMAKE_CURRENT_LIST_DIR}/commandpush.cpp ${CMAKE_CURRENT_LIST_DIR}/commandpush.h

    PARENT_SCOPE
)

ecm_generate_headers(libkommit_CamelCase_HEADERS
    HEADER_NAMES

        CommandSwitchBranch
        CommandMerge
        CommandChangedFiles
        AddSubmoduleUommand
        AbstractUommand
        ParameteresCommand
        CommandPush
        CommandPull
        CommandFetch
        CommandCommit
        CommandClone
        CommandClean
        CommandAddRemote
PREFIX Kommit
    REQUIRED_HEADERS kommit_HEADERS
    RELATIVE
        commands
)

=== debian/changelog ===
kommit (1.6.0+p24.04+vunstable+git20251009.0706-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 09 Oct 2025 07:06:30 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@ --with kf6 --buildsystem=kf6

override_dh_auto_configure:
	dh_auto_configure -- -DCOMPILE_WITH_UNITY_CMAKE_SUPPORT=ON -DBUILD_WITH_QT6=ON

.PHONY: override_dh_auto_test

## kommit 1.6.0+p24.04+vunstable+git20251015.1830

=== debian/changelog ===
kommit (1.6.0+p24.04+vunstable+git20251015.1830-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 15 Oct 2025 18:30:49 +0000

## kommit 1.6.0+p24.04+vunstable+git20251123.1852

=== icons/CMakeLists.txt ===
set(KOMMIT_ICONS
  16-apps-kommit.png
  22-apps-kommit.png
  32-apps-kommit.png
  48-apps-kommit.png
  sc-apps-kommit.svg
)

ecm_install_icons(ICONS ${KOMMIT_ICONS} DESTINATION ${KDE_INSTALL_ICONDIR} THEME hicolor)

=== dolphinplugins/autotests/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
     add_executable(${_name} ${_test} ${ARGN} ${_name}.h)
     add_test(NAME ${_name} COMMAND ${_name})
     ecm_mark_as_test(${_name})
-    target_link_libraries(${_name} Qt::Test libkommitgui DolphinVcs Libgit2)
+    target_link_libraries(${_name} Qt::Test libkommitgui DolphinVcs LibGit2::LibGit2)
 endmacro()
 
 add_dolphinplugins_test(overlaytest.cpp)

=== debian/changelog ===
kommit (1.6.0+p24.04+vunstable+git20251123.1852-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 23 Nov 2025 18:52:24 +0000

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,8 @@
                libgit2-dev,
                pkg-kde-tools-neon,
                qt6-base,
-               qt6-charts-dev
+               qt6-charts-dev,
+               qt6-svg-dev
 Standards-Version: 4.6.2
 Homepage: https://invent.kde.org/sdk/kommit
 Vcs-Git: https://invent.kde.org/neon/neon-packaging/kommit.git

## kommit 1.6.0+p24.04+vunstable+git20251201.0321

=== debian/changelog ===
kommit (1.6.0+p24.04+vunstable+git20251201.0321-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 01 Dec 2025 03:21:39 +0000
